unit Shortcut;

//27.01.2001 by Peric


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,ShlObj, ComObj, ActiveX, registry;
  {$R SHORTCUT.res}
type
  TShortcut = class(TComponent)
  private
  FDirinStartmenu : string;
  FMake,FMakeOnDesktop,FMakeOnStarTMenu:boolean;
  FCop: string;
  function GetCop: string;
  function GetDirinStartmenu: string;
  function CreateShortcut(const CmdLine, Args, WorkDir, LinkFile: string):IPersistFile;
  procedure SetDirinStartmenu(ADirinStartmenu: string);
  procedure SetMake(AMake:boolean);
  procedure SetMakeOnDesktop(AMakeOnDesktop:boolean);
  procedure SetMakeOnStarTMenu(AMakeOnStarTMenu:boolean);
  procedure CreateShortcuts;
  procedure SetCop(const Value: string);
  { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
     constructor Create(Aowner:Tcomponent);override;
  published
    { Published declarations }
      property MakeOnDesktop:boolean
    read FMakeOnDesktop write SetMakeOnDesktop default True;
      property MakeOnStartMenu:boolean
    read FMakeOnStarTMenu write SetMakeOnStarTMenu default True;
      property Make:boolean
    read FMake write SetMake default False;
    property NameSubDirInStartMenu:string
    read GetDirinStartmenu write SetDirinStartmenu;
    property Copyright: string read GetCop write SetCop;
  end;

procedure Register;

implementation


    constructor TShortcut.Create(AOwner:TComponent);

begin
     inherited;
     MakeOnStartMenu:=true;
     MakeOnDesktop:=true;
     Make:=false;
     NameSubDirInStartmenu:='';
     FCop:='Copyright  2001 by Peric';
end;

function TShortcut.GetCop: string;
begin
Result:=FCop;
end;


procedure TShortcut.SetCop(const Value: string);
begin
FCop:=FCop;
end;



function TShortcut.CreateShortcut(const CmdLine, Args, WorkDir, LinkFile: string): IPersistFile;

var
MyObject : IUnknown;
MySLink : IShellLink;
MyPFile : IPersistFile;
WideFile : WideString;
begin
MyObject := CreateComObject(CLSID_ShellLink);
MySLink := MyObject as IShellLink;
MyPFile := MyObject as IPersistFile;
with MySLink do
begin
SetPath(PChar(CmdLine));
SetArguments(PChar(Args));
SetWorkingDirectory(PChar(WorkDir));
end;
WideFile := LinkFile;
MyPFile.Save(PWChar(WideFile), False);
Result := MyPFile;
end;

procedure TShortcut.CreateShortcuts;
var Directory, ExecDir,start: String;
MyReg: TRegIniFile;
begin

ExecDir:=ExtractFilePath(application.exename);
MyReg := TRegIniFile.Create('Software\MicroSoft\Windows\CurrentVersion\Explorer');

start := MyReg.ReadString('Shell Folders','Start Menu','')+'\Programs\'+FDirinStartmenu;
if not FMakeOnStarTMenu then
begin
end
else
begin
CreateDir(start);
end;

Directory := MyReg.ReadString('Shell Folders','Desktop','');
CreateDir(Directory);
MyReg.Free;

if FMakeOnDesktop then
CreateShortcut(ExecDir +'/'+Application.Title+'.exe', '', ExecDir,
Directory +'/'+ Application.Title+'.lnk');

If FMakeOnStarTMenu then
CreateShortcut(ExecDir +'/'+Application.Title+'.exe', '', ExecDir,
start +'/'+ Application.Title+'.lnk');

end;

    function TShortcut.GetDirinStartmenu: string;
begin
     Result:=FDirinStartmenu;
end;


    procedure TShortcut.SetDirinStartmenu(ADirinStartmenu:string);
begin
     FDirinStartmenu:=ADirinStartmenu;
end;


procedure TShortcut.SetMake(AMake:boolean);
begin
     FMake:=AMake;
     if csDesigning in ComponentState then
     Exit;

     if FMake = true then
     begin
     CreateShortcuts;
     end;
end;

procedure TShortcut.SetMakeOnStarTMenu (AMakeOnStarTMenu :boolean);
begin
     FMakeOnStarTMenu :=AMakeOnStarTMenu ;
end;

procedure TShortcut.SetMakeOnDesktop (AMakeOnDesktop :boolean);
begin
     FMakeOnDesktop :=AMakeOnDesktop ;
end;

procedure Register;
begin
  RegisterComponents('PDJ', [TShortcut]);
end;

end.
